* Program..:  Memotest.PRG  
* Author...:  Kenneth N. Getz  
* Date.....:  January 1, 1988  
* Notes....:  Memotest.PRG is a test program for Ismemo.BIN.  It walks through  
*             a database file and reports on the memo field status of each  
*             record.  
*  
*             Requires the program Findoffs.PRG to calculate the offset  
*             within the record of the requested memo field.  
*   
SET TALK OFF  
LOAD Ismemo  
CLEAR  
*  
* ---Initialize variables.  
paramstr  = SPACE(75)  
filename  = SPACE(64)  
fieldname = space(10)  
offset    = 0  
*  
* ---Get the file and field names.  
@ 1,1 SAY "Filename   : " GET filename  
@ 2,1 SAY "Memo field : " GET fieldname  
READ  
CLEAR  
*  
* ---Figure the offset within the record.  
DO Findoffs WITH filename, fieldname, offset  
IF offset < 0
   ? UPPER(TRIM(IIF(offset = -1, filename, fieldname))) +;
                     " not found.  Halting..."
   RETURN  
ENDIF  
USE &filename  
DO WHILE .NOT. EOF()     
   *     
   * ---Build the parameter string.
   paramstr = STR(offset, 4) + STR(RECNO(), 10) + DBF()
   CALL Ismemo WITH paramstr     
   *     
   * ---A space indicates no error.  Anything else means something went     
   * ---wrong.
   IF LEFT(paramstr, 1) <> CHR(32)
      ? "Error number " + STR(ASC(LEFT(paramstr, 1)), 1, 0) + ;
           " at record " + LTRIM(STR(RECNO(), 10)) + "."
      EXIT
   ELSE        
      *        
      * ---If the second character is a "Y", there was a memo field.
      ok = (SUBSTR(paramstr, 2, 1) = "Y")
      ? "RECORD " + LTRIM(STR(RECNO(), 10)) + " DOES "
      ?? IIF(ok, SPACE(4), "NOT ") + "CONTAIN A MEMO."
      SKIP
   ENDIF  
ENDDO  
* EOP Memotest.PRG
